#!/bin/bash
: '
This script is licensed under the AGPL v3
(c)2025 kxtzownsu
'
SCRIPT_DIR=$(dirname "$0")
SCRIPT_DIR=${SCRIPT_DIR:-"."}

cat <<EOF
This script will: 
- Clone Vencord
- Install the plugin to Vencord's source
- Build Vencord

If you do not have 'pnpm' and 'node' installed, press CTRL+C and install them now

Otherwise, press ENTER 3 times to continue.
EOF
read -r
read -r
read -r

git clone https://github.com/Vendicated/Vencord $SCRIPT_DIR/Vencord
cd $SCRIPT_DIR/Vencord
mkdir -p src/plugins/sentFromMyDevice
cp ../index.ts src/plugins/sentFromMyDevice/
pnpm i
pnpm build
cat <<EOF
=============
Build process finished! Final built files are available at $SCRIPT_DIR/Vencord/dist
EOF
exit 0
